#!/usr/bin/python

import sys
from lib.libexploit import CIngumaModule

try:
    import cx_Oracle
    oracleSupport = True
except:
    print sys.exc_info()[1]
    oracleSupport = False

name = "oratool"
brief_description = "Oracle wrapper for all related stuff"
type = "gather"

class COracleMode(CIngumaModule):

    sid = "orcl"
    dad = ""
    user = "test"
    password = "test"

    connection = None

    def help(self):
        print "target = <target host or network>"
        print "port = <target port>"
        print "sid = <sid name>"
        print "user = <database's username>"
        print "password = <user's password>"

    def showHelp(self):
        print
        print "Inguma's Oracle mode help"
        print "-------------------------"
        print
        print "help                         Show this help"
        print "exit                         Exit from oracle mode"
        print "sql                          Opens an interactive SQL terminal"
        print "sid=<sid>                    Specify the database's SID"
        print "dad=<dad>                    Specify the server's DAD name"
        print "user=<user>                  Specify the user to use"
        print "password=<password>          Specify the password to use"
        print "print <var>                  Print the value of one variable"
        print
        print "Any other typed expression will be evaled as a python expression"
        print

    def connect(self):

        link    = "%s/%s@(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=%d)))"
        link += "(CONNECT_DATA=(SERVICE_NAME=%s)))"
        link    = link % (self.user, self.password, self.target, self.port, self.sid)

        self.connection = cx_Oracle.connect(link)
        self.connection.rollback()
        self.connection.commit()

    def funnyTerminal(self):
        pass

    def runSQLCommand(self, sql, pprint=True, *params):
        cur = self.connection.cursor()
        cur.execute(sql, *params)

        if sql.lower().find("select") > -1:
            buf = ""
            for col in cur.description:
                buf += col[0] + "\t"

            print buf
            print "-" * len(buf)

            for row in cur.fetchall():
                buf = ""
                for col in row:
                    buf += str(col) + "\t"
                print buf
            print
            print "Total of",cur.rowcount, "row(s) selected."
        else:
            print "Statement executed."

    def sqlLoop(self):
        self.connect()

        buf = ""

        print "Type ';' in a single line to run a command. Exit to quit."

        while 1:
            try:
                res = raw_input("SQL> ")

                if res.lower() == "exit" or res.lower() == "quit":
                    break
                elif res == ";":
                    self.runSQLCommand(buf, True)
                    buf = ""
                else:
                    buf += res + "\n"

            except KeyboardInterrupt:
                break
            except EOFError:
                break
            except:
                print "SQL Error:", sys.exc_info()[1]
                buf = ""

    def showExploits(self):
        pass

    def runOracleModeLoop(self):

        dad = self.dad
        sid = self.sid
        port = self.port
        target = self.target
        user = self.user
        password = self.password

        while 1:
            try:
                self.dad = dad
                self.sid = sid
                self.target = target
                self.port = port
                self.user = user
                self.password = password

                res = raw_input("ORAMODE> ")
            except KeyboardInterrupt:
                break
            except EOFError:
                break
            except:
                print "raw_input:", sys.exc_info()[1]
            
            words = res.split(" ")

            if len(words) == 1 and words[0] == "":
                continue
            elif words[0].lower() == "exit" or words[0].lower() == "quit":
                break
            elif words[0].lower() == "help":
                self.showHelp()
            elif words[0].lower() == "sql":
                self.sqlLoop()
            elif words[0].lower() == "show" and words[1].lower() == "exploits":
                self.showExploits()
            else:
                try:
                    exec(res)
                except:
                    print "Error:",sys.exc_info()[1]

        return True

    def run(self):
        if not oracleSupport:
            print "No support for cx_Oracle. Please, install it first."
            return False

        self.runOracleModeLoop()

        return True

    def printSummary(self):
        pass
