#!/usr/bin/python

import os

try:
    if os.name == "nt":
        import _winreg
except:
    print "No Winreg support."

name = "winspdetect"
brief_description = "Detect service pack using remote registry (LAME)"
type = "gather"

class CSpDetect:

    target = ""
    waitTime = 0
    timeout = 1
    exploitType = 1
    wizard = False
    services = {}
    results = {}
    string = ""

    def run(self):
        if os.name != "nt":
            print "Only supported under Win32 platforms"
            return False

        self.results = {}
        host = _winreg.ConnectRegistry(self.target, _winreg.HKEY_LOCAL_MACHINE)
        key = _winreg.OpenKey(host, "Software\\Microsoft\\Windows NT\\CurrentVersion\\")
        os_name, sp_ver =  _winreg.QueryValueEx(key, "ProductName")[0],_winreg.QueryValueEx(key,"CSDVersion")[0]
        self.string = os_name + " " + sp_ver

        return True

    def printSummary(self):
        print self.string


if __name__ == "__main__":

    objSp = CSpDetect()
    objSp.target = "127.0.0.1"
    objSp.run()
    objSp.printSummary()
