#!/usr/bin/python

import sys
import time
import socket

from lib.libexploit import CIngumaModule

name = "tcpscan"
brief_description = "Simple TCP port scanner"
type = "gather"

class CTCPScan(CIngumaModule):
    opened = {}
    closed = {}
    exploitType = 1

    def help(self):
        print "target = <target host or network>"
        print "timeout = <timeout>"

    def run(self):
        self.opened = {}
        self.closed = {}

        for port in self.ports:
            try:
                socket.setdefaulttimeout(self.timeout)
                s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                s.connect((self.target, port))
                s.close()

                self.opened[port] = "open"
                self.addToDict(self.target + "_ports", port)

            except:
                self.closed[port] = "close"

        return True

    def printSummary(self):
        print
        print "Open ports"
        print "----------"
        print
        for opened in self.opened:
            try:
                port_name = socket.getservbyport(opened)
                port_name = str(opened) + "/" + port_name
            except:
                port_name = str(opened)

            print "Port",port_name,"is open"

        print
